﻿using Monorail.DrawningObjects;
using Monorail.Generics;
using Monorail.MovementStrategy;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Monorail.Generics
{
    internal class MonorailGenericStorage
    {
        readonly Dictionary<string, MonorailGenericCollection<DrawningMonorail, DrawningObjectMonorail>> _monorailStorages;
        public List<string> Keys => _monorailStorages.Keys.ToList();

        private readonly int _pictureWidth;

        private readonly int _pictureHeight;

        public MonorailGenericStorage(int pictureWidth, int pictureHeight)
        {
            _monorailStorages = new Dictionary<string,
                MonorailGenericCollection<DrawningMonorail, DrawningObjectMonorail>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }

        public void AddSet(string name)
        {
            _monorailStorages.Add(name, new MonorailGenericCollection<DrawningMonorail, DrawningObjectMonorail>(_pictureWidth, _pictureHeight));
        }

        public void DelSet(string name)
        {
            if (!_monorailStorages.ContainsKey(name))
                return;
            _monorailStorages.Remove(name);
        }

        public MonorailGenericCollection<DrawningMonorail, DrawningObjectMonorail>? this[string ind]
        {
            get
            {
                if (_monorailStorages.ContainsKey(ind))
                    return _monorailStorages[ind];
                return null;
            }
        }
    }
}
